/* A Bison parser, made by GNU Bison 2.0.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     TOK_NAME = 258,
     TOK_NUMBER = 259,
     TOK_STRING = 260,
     TOK_OBJECT = 261,
     TOK_BLOCK = 262,
     TOK_PROP_NIL = 263,
     TOK_PROP_BOOL = 264,
     TOK_PROP_NUM = 265,
     TOK_PROP_STR = 266,
     TOK_PROP_ARR = 267,
     TOK_VAR_NIL = 268,
     TOK_VAR_BOOL = 269,
     TOK_VAR_NUM = 270,
     TOK_VAR_STR = 271,
     TOK_VAR_ARR = 272,
     TOK_RANGE = 273,
     TOK_EQ = 274,
     TOK_NE = 275,
     TOK_GE = 276,
     TOK_LE = 277,
     TOK_OR = 278,
     TOK_AND = 279,
     TOK_TRUE = 280,
     TOK_FALSE = 281,
     TOK_LENGTH = 282,
     TOK_IF = 283,
     TOK_ELSE = 284,
     UMINUS = 285
   };
#endif
#define TOK_NAME 258
#define TOK_NUMBER 259
#define TOK_STRING 260
#define TOK_OBJECT 261
#define TOK_BLOCK 262
#define TOK_PROP_NIL 263
#define TOK_PROP_BOOL 264
#define TOK_PROP_NUM 265
#define TOK_PROP_STR 266
#define TOK_PROP_ARR 267
#define TOK_VAR_NIL 268
#define TOK_VAR_BOOL 269
#define TOK_VAR_NUM 270
#define TOK_VAR_STR 271
#define TOK_VAR_ARR 272
#define TOK_RANGE 273
#define TOK_EQ 274
#define TOK_NE 275
#define TOK_GE 276
#define TOK_LE 277
#define TOK_OR 278
#define TOK_AND 279
#define TOK_TRUE 280
#define TOK_FALSE 281
#define TOK_LENGTH 282
#define TOK_IF 283
#define TOK_ELSE 284
#define UMINUS 285




/* Copy the first part of user declarations.  */
#line 1 "graal.y"

/*
 * Grace - GRaphing, Advanced Computation and Exploration of data
 * 
 * Home page: http://plasma-gate.weizmann.ac.il/Grace/
 * 
 * Copyright (c) 2006 Grace Development Team
 * 
 * Maintained by Evgeny Stambulchik
 * 
 * 
 *                           All Rights Reserved
 * 
 *    This program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 * 
 *    This program is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 * 
 *    You should have received a copy of the GNU General Public License
 *    along with this program; if not, write to the Free Software
 *    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "grace/baseP.h"
#include "grace/graalP.h"

#include "parser.h"
#include "scanner.h"

#define YYPARSE_PARAM scanner
#define YYLEX_PARAM   scanner

#define REGISTER_DARR(da)   graal_register_darr(yyget_extra(scanner), da)
#define SET_DOTCONTEXT(ctx) graal_set_dotcontext(yyget_extra(scanner), ctx)

void yyerror(char *s)
{
    errmsg(s);
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 51 "graal.y"
typedef union YYSTYPE {
    int    ival;
    double dval;
    DArray *darr;
    char   *sval;
    void   *gobj;
    GVar   *gvar;
} YYSTYPE;
/* Line 190 of yacc.c.  */
#line 192 "parser.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

#if ! defined (YYLTYPE) && ! defined (YYLTYPE_IS_DECLARED)
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 213 of yacc.c.  */
#line 216 "parser.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYLTYPE_IS_TRIVIAL) && YYLTYPE_IS_TRIVIAL \
             && defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
    YYLTYPE yyls;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   466

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  54
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  16
/* YYNRULES -- Number of rules. */
#define YYNRULES  105
/* YYNRULES -- Number of states. */
#define YYNSTATES  213

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   285

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    53,     2,     2,     2,    39,     2,     2,
      48,    49,    37,    35,    50,    34,    46,    38,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    31,    42,
      33,    43,    32,    30,    36,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    44,     2,    45,    41,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    51,     2,    52,    47,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    40
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     4,     8,     9,    13,    17,    21,    25,
      29,    33,    37,    41,    46,    51,    56,    61,    68,    73,
      78,    83,    88,    93,    99,   105,   111,   117,   120,   123,
     126,   129,   132,   135,   137,   139,   141,   143,   145,   147,
     149,   151,   155,   159,   163,   167,   171,   175,   178,   181,
     185,   190,   196,   201,   206,   208,   212,   214,   215,   217,
     221,   225,   227,   231,   233,   240,   244,   248,   252,   256,
     260,   264,   268,   272,   276,   280,   284,   288,   292,   295,
     298,   302,   304,   306,   308,   312,   316,   323,   325,   327,
     329,   333,   337,   341,   345,   349,   353,   357,   361,   365,
     369,   373,   376,   380,   382,   383
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      55,     0,    -1,    -1,    55,    56,    42,    -1,    -1,     3,
      43,    59,    -1,     3,    43,    67,    -1,     3,    43,    64,
      -1,     3,    43,    66,    -1,    58,    43,    59,    -1,    58,
      43,    67,    -1,    58,    43,    64,    -1,    58,    43,    66,
      -1,    15,    35,    43,    59,    -1,    15,    34,    43,    59,
      -1,    15,    37,    43,    59,    -1,    15,    38,    43,    59,
      -1,    17,    44,    61,    45,    43,    59,    -1,    17,    35,
      43,    59,    -1,    17,    34,    43,    59,    -1,    17,    37,
      43,    59,    -1,    17,    38,    43,    59,    -1,    16,    36,
      43,    66,    -1,    68,    46,     3,    43,    59,    -1,    68,
      46,     3,    43,    67,    -1,    68,    46,     3,    43,    66,
      -1,    68,    46,     3,    43,    64,    -1,    57,    59,    -1,
      57,    67,    -1,    57,    64,    -1,    57,    66,    -1,    57,
      13,    -1,    47,    58,    -1,    30,    -1,    13,    -1,    15,
      -1,    14,    -1,    17,    -1,    16,    -1,     4,    -1,    15,
      -1,    68,    46,    10,    -1,    59,    35,    59,    -1,    59,
      34,    59,    -1,    59,    37,    59,    -1,    59,    38,    59,
      -1,    59,    41,    59,    -1,    34,    59,    -1,    35,    59,
      -1,    48,    59,    49,    -1,    63,    44,    61,    45,    -1,
      67,    30,    59,    31,    59,    -1,    27,    48,    64,    49,
      -1,    27,    48,    66,    49,    -1,    59,    -1,    60,    39,
      60,    -1,    60,    -1,    -1,    59,    -1,    62,    50,    59,
      -1,    51,    62,    52,    -1,    17,    -1,    68,    46,    12,
      -1,    63,    -1,    63,    44,    61,    18,    61,    45,    -1,
      64,    36,    64,    -1,    64,    35,    59,    -1,    59,    35,
      64,    -1,    64,    35,    64,    -1,    64,    34,    59,    -1,
      59,    34,    64,    -1,    64,    34,    64,    -1,    64,    37,
      59,    -1,    59,    37,    64,    -1,    64,    37,    64,    -1,
      64,    38,    59,    -1,    64,    38,    64,    -1,    64,    41,
      59,    -1,    34,    64,    -1,    35,    64,    -1,    48,    64,
      49,    -1,     5,    -1,    16,    -1,    65,    -1,    68,    46,
      11,    -1,    66,    36,    66,    -1,    65,    44,    61,    18,
      61,    45,    -1,    25,    -1,    26,    -1,    14,    -1,    68,
      46,     9,    -1,    59,    19,    59,    -1,    59,    20,    59,
      -1,    59,    22,    59,    -1,    59,    21,    59,    -1,    59,
      33,    59,    -1,    59,    32,    59,    -1,    67,    19,    67,
      -1,    67,    20,    67,    -1,    67,    23,    67,    -1,    67,
      24,    67,    -1,    53,    67,    -1,    48,    67,    49,    -1,
       6,    -1,    -1,    68,    31,    69,     6,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   122,   122,   123,   126,   127,   135,   143,   151,   162,
     168,   174,   180,   189,   194,   199,   204,   214,   224,   229,
     234,   239,   249,   258,   268,   278,   289,   299,   304,   309,
     314,   320,   325,   328,   331,   332,   333,   334,   335,   338,
     339,   342,   345,   346,   347,   348,   356,   367,   368,   369,
     370,   378,   379,   380,   386,   395,   405,   415,   418,   425,
     431,   432,   440,   447,   448,   461,   465,   472,   479,   491,
     498,   506,   518,   524,   531,   543,   555,   570,   583,   590,
     591,   594,   595,   602,   603,   606,   610,   632,   633,   634,
     637,   640,   641,   642,   643,   644,   645,   646,   647,   648,
     649,   650,   651,   654,   659,   659
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "TOK_NAME", "TOK_NUMBER", "TOK_STRING",
  "TOK_OBJECT", "TOK_BLOCK", "TOK_PROP_NIL", "TOK_PROP_BOOL",
  "TOK_PROP_NUM", "TOK_PROP_STR", "TOK_PROP_ARR", "TOK_VAR_NIL",
  "TOK_VAR_BOOL", "TOK_VAR_NUM", "TOK_VAR_STR", "TOK_VAR_ARR", "TOK_RANGE",
  "TOK_EQ", "TOK_NE", "TOK_GE", "TOK_LE", "TOK_OR", "TOK_AND", "TOK_TRUE",
  "TOK_FALSE", "TOK_LENGTH", "TOK_IF", "TOK_ELSE", "'?'", "':'", "'>'",
  "'<'", "'-'", "'+'", "'@'", "'*'", "'/'", "'%'", "UMINUS", "'^'", "';'",
  "'='", "'['", "']'", "'.'", "'~'", "'('", "')'", "','", "'{'", "'}'",
  "'!'", "$accept", "input", "line", "eval_anon", "avar", "expr", "iexpr",
  "nexpr", "list", "array", "vexpr", "sarray", "sexpr", "bexpr", "object",
  "@1", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
      63,    58,    62,    60,    45,    43,    64,    42,    47,    37,
     285,    94,    59,    61,    91,    93,    46,   126,    40,    41,
      44,   123,   125,    33
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    54,    55,    55,    56,    56,    56,    56,    56,    56,
      56,    56,    56,    56,    56,    56,    56,    56,    56,    56,
      56,    56,    56,    56,    56,    56,    56,    56,    56,    56,
      56,    56,    56,    57,    58,    58,    58,    58,    58,    59,
      59,    59,    59,    59,    59,    59,    59,    59,    59,    59,
      59,    59,    59,    59,    60,    60,    61,    62,    62,    62,
      63,    63,    63,    64,    64,    64,    64,    64,    64,    64,
      64,    64,    64,    64,    64,    64,    64,    64,    64,    64,
      64,    65,    65,    66,    66,    66,    66,    67,    67,    67,
      67,    67,    67,    67,    67,    67,    67,    67,    67,    67,
      67,    67,    67,    68,    69,    68
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     3,     0,     3,     3,     3,     3,     3,
       3,     3,     3,     4,     4,     4,     4,     6,     4,     4,
       4,     4,     4,     5,     5,     5,     5,     2,     2,     2,
       2,     2,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     3,     2,     2,     3,
       4,     5,     4,     4,     1,     3,     1,     0,     1,     3,
       3,     1,     3,     1,     6,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       3,     1,     1,     1,     3,     3,     6,     1,     1,     1,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     2,     3,     1,     0,     4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     4,     1,     0,   103,    34,    36,    35,    38,    37,
      33,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    35,    38,    37,
      32,     3,    39,    81,    31,    89,    40,    82,    61,    87,
      88,     0,     0,     0,     0,    57,     0,    27,    63,    29,
      83,    30,    28,     0,     0,   104,     0,     5,     7,     8,
       6,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    54,    56,     0,     0,     0,     0,     0,
      47,    78,    48,    79,     0,     0,     0,    58,     0,     0,
     101,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     9,    11,    12,
      10,     0,     0,    14,    13,    15,    16,    22,     0,    19,
      18,    20,    21,    47,    48,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    49,    80,   102,     0,
      60,    91,    92,    94,    93,    96,    95,    43,    70,    42,
      67,    44,    73,    45,    46,     0,    69,    71,    66,    68,
      65,    72,    74,    75,    76,    77,     0,    85,    97,    98,
      99,   100,     0,    90,    41,    84,    62,   105,     0,     0,
      43,    42,    44,    55,     0,     0,    52,    53,    59,     0,
      50,     0,     0,    23,    26,    25,    24,    17,     0,     0,
      51,    64,    86
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
      -1,     1,    12,    13,    14,    73,    74,    75,    88,    76,
      49,    50,    51,    77,    78,   121
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -37
static const short int yypact[] =
{
     -37,    22,   -37,   -36,   -37,   -37,   -37,   100,   -26,    74,
     -37,    29,   -28,   238,    24,   -30,   242,    30,    33,    73,
      76,    78,    79,    99,   102,   104,   188,   -37,   -37,   -37,
     -37,   -37,   -37,   -37,   -37,   -37,   -37,   -37,   -37,   -37,
     -37,   107,   288,   288,   288,   188,   188,   379,   106,   246,
     112,   -18,   109,   -29,   242,   -37,   160,   379,   246,   -18,
     109,   188,   188,   188,   188,    56,   188,   188,   188,   188,
     188,   188,   188,   402,   122,   142,   144,   109,   -25,   242,
     152,   156,   152,   156,   310,   263,   -15,   402,    13,   402,
     -37,   188,   188,   188,   188,   188,   188,   288,   288,   288,
     188,   188,   188,   288,   288,   288,   288,   288,   188,   188,
      56,   188,   188,   188,   188,   188,   174,   379,   246,   -18,
     109,   194,   169,   402,   402,   402,   402,   -18,   -19,   402,
     402,   402,   402,   152,   152,   333,   188,   188,   188,   188,
     177,   188,   164,   379,   369,    11,   -37,   -37,   -37,   188,
     -37,   425,   425,   425,   425,   425,   425,    89,   111,    89,
     111,   152,   156,   152,   152,    -5,   158,   111,   158,   111,
     111,   197,   156,   197,   156,   197,   183,   -37,    51,    51,
       0,    77,   356,   -37,   -37,   -37,   -37,   -37,   242,   210,
     116,   116,   152,   -37,   188,   179,   -37,   -37,   402,   188,
     -37,   188,   188,   379,   246,   -18,   109,   402,   192,   200,
     402,   -37,   -37
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
     -37,   -37,   -37,   -37,   217,   -13,   121,     5,   -37,    61,
     128,   -37,    52,    97,    10,   -37
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const short int yytable[] =
{
      47,    55,    55,    57,   111,   112,    55,    16,   113,   114,
      21,    15,    55,   199,    31,   115,    56,   116,   110,   111,
     112,   142,     2,    53,   114,     3,    53,   189,     4,    80,
      82,    84,    87,    89,   148,     5,     6,     7,     8,     9,
     200,   117,     5,     6,    27,    28,    29,   110,   123,   124,
     125,   126,    10,   129,   130,   131,   132,   133,   134,   135,
     197,    33,     4,   149,    53,   150,   143,    54,    59,    11,
      -1,    -1,    37,    61,    48,   128,    62,    48,   151,   152,
     153,   154,   155,   156,   157,   159,   161,   163,   164,    53,
     166,   168,   143,   171,   173,   175,   111,   112,    89,    89,
      89,    89,   182,    48,    48,    48,   119,   165,    22,    23,
      52,    24,    25,    60,   176,    48,    63,   127,    26,    64,
     128,    65,    66,   190,   191,   192,    99,   100,   111,   112,
     101,   145,   113,   114,    17,    18,   198,    19,    20,   115,
      48,    86,    67,    90,    58,    68,   195,    69,   106,   107,
     102,   120,   108,   138,   100,    79,   109,   101,    48,    48,
      48,   139,   177,   122,    48,    48,    48,    48,    48,    86,
      81,    83,    85,   183,   184,   203,   186,    91,    92,    93,
      94,   207,   118,   183,   184,   185,   186,   140,   141,   210,
      95,    96,    32,   101,     4,    99,   100,   108,    53,   101,
     187,   201,    35,    36,   208,    38,   209,   144,   178,   179,
     180,   181,   188,    39,    40,    41,    91,    92,    93,    94,
     194,   185,    70,    71,   200,   158,   160,   162,    30,    95,
      96,   167,   169,   170,   172,   174,    72,   211,   101,    45,
     205,    46,    32,    33,     4,   212,    32,    33,     4,    48,
       0,    34,    35,    36,    37,    38,    35,    36,    37,    38,
     193,     0,     0,    39,    40,    41,     0,    39,    40,    41,
       0,     0,    42,    43,     0,     0,    42,    43,     0,     0,
     103,   104,   105,   106,   107,   206,    44,   108,     0,    45,
      44,    46,    32,    45,     4,    46,     0,   103,   104,   105,
     106,   107,    35,    36,   108,    38,     0,     0,     0,     0,
       0,     0,   147,    39,    40,    41,   204,     0,     0,     0,
       0,     0,    42,    43,     0,     0,     0,     0,     0,    91,
      92,    93,    94,     0,     0,     0,    44,     0,     0,    45,
       0,    46,    95,    96,    97,    98,     0,    99,   100,     0,
       0,   101,    91,    92,    93,    94,     0,     0,     0,   146,
       0,     0,     0,     0,     0,    95,    96,   136,   137,     0,
     138,   100,     0,     0,   101,    91,    92,    93,    94,     0,
       0,     0,   146,     0,     0,     0,     0,   202,    95,    96,
     136,   137,     0,   138,   100,     0,     0,   101,    91,    92,
      93,    94,     0,   103,   104,   105,   106,   107,     0,     0,
     108,    95,    96,    97,    98,     0,    99,   100,   196,     0,
     101,    91,    92,    93,    94,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    95,    96,   136,   137,     0,   138,
     100,     0,     0,   101,    -1,    -1,    93,    94,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    95,    96,   136,
     137,     0,   138,   100,     0,     0,   101
};

static const short int yycheck[] =
{
      13,    31,    31,    16,    19,    20,    31,    43,    23,    24,
      36,     1,    31,    18,    42,    30,    46,    46,    36,    19,
      20,    46,     0,    13,    24,     3,    16,    46,     6,    42,
      43,    44,    45,    46,    49,    13,    14,    15,    16,    17,
      45,    54,    13,    14,    15,    16,    17,    36,    61,    62,
      63,    64,    30,    66,    67,    68,    69,    70,    71,    72,
      49,     5,     6,    50,    54,    52,    79,    43,    16,    47,
      19,    20,    16,    43,    13,    65,    43,    16,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,    79,
     103,   104,   105,   106,   107,   108,    19,    20,   111,   112,
     113,   114,   115,    42,    43,    44,    54,   102,    34,    35,
      13,    37,    38,    16,   109,    54,    43,    65,    44,    43,
     110,    43,    43,   136,   137,   138,    37,    38,    19,    20,
      41,    79,    23,    24,    34,    35,   149,    37,    38,    30,
      79,    44,    43,    46,    16,    43,   141,    43,    37,    38,
      44,    54,    41,    37,    38,    48,    44,    41,    97,    98,
      99,    39,   110,     3,   103,   104,   105,   106,   107,    72,
      42,    43,    44,     9,    10,   188,    12,    19,    20,    21,
      22,   194,    54,     9,    10,    11,    12,    45,    44,   202,
      32,    33,     4,    41,     6,    37,    38,    41,   188,    41,
       6,    18,    14,    15,   199,    17,   201,    79,   111,   112,
     113,   114,    43,    25,    26,    27,    19,    20,    21,    22,
      43,    11,    34,    35,    45,    97,    98,    99,    11,    32,
      33,   103,   104,   105,   106,   107,    48,    45,    41,    51,
     188,    53,     4,     5,     6,    45,     4,     5,     6,   188,
      -1,    13,    14,    15,    16,    17,    14,    15,    16,    17,
     139,    -1,    -1,    25,    26,    27,    -1,    25,    26,    27,
      -1,    -1,    34,    35,    -1,    -1,    34,    35,    -1,    -1,
      34,    35,    36,    37,    38,   188,    48,    41,    -1,    51,
      48,    53,     4,    51,     6,    53,    -1,    34,    35,    36,
      37,    38,    14,    15,    41,    17,    -1,    -1,    -1,    -1,
      -1,    -1,    49,    25,    26,    27,   188,    -1,    -1,    -1,
      -1,    -1,    34,    35,    -1,    -1,    -1,    -1,    -1,    19,
      20,    21,    22,    -1,    -1,    -1,    48,    -1,    -1,    51,
      -1,    53,    32,    33,    34,    35,    -1,    37,    38,    -1,
      -1,    41,    19,    20,    21,    22,    -1,    -1,    -1,    49,
      -1,    -1,    -1,    -1,    -1,    32,    33,    34,    35,    -1,
      37,    38,    -1,    -1,    41,    19,    20,    21,    22,    -1,
      -1,    -1,    49,    -1,    -1,    -1,    -1,    31,    32,    33,
      34,    35,    -1,    37,    38,    -1,    -1,    41,    19,    20,
      21,    22,    -1,    34,    35,    36,    37,    38,    -1,    -1,
      41,    32,    33,    34,    35,    -1,    37,    38,    49,    -1,
      41,    19,    20,    21,    22,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    32,    33,    34,    35,    -1,    37,
      38,    -1,    -1,    41,    19,    20,    21,    22,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    32,    33,    34,
      35,    -1,    37,    38,    -1,    -1,    41
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    55,     0,     3,     6,    13,    14,    15,    16,    17,
      30,    47,    56,    57,    58,    68,    43,    34,    35,    37,
      38,    36,    34,    35,    37,    38,    44,    15,    16,    17,
      58,    42,     4,     5,    13,    14,    15,    16,    17,    25,
      26,    27,    34,    35,    48,    51,    53,    59,    63,    64,
      65,    66,    67,    68,    43,    31,    46,    59,    64,    66,
      67,    43,    43,    43,    43,    43,    43,    43,    43,    43,
      34,    35,    48,    59,    60,    61,    63,    67,    68,    48,
      59,    64,    59,    64,    59,    64,    67,    59,    62,    59,
      67,    19,    20,    21,    22,    32,    33,    34,    35,    37,
      38,    41,    44,    34,    35,    36,    37,    38,    41,    44,
      36,    19,    20,    23,    24,    30,    46,    59,    64,    66,
      67,    69,     3,    59,    59,    59,    59,    66,    68,    59,
      59,    59,    59,    59,    59,    59,    34,    35,    37,    39,
      45,    44,    46,    59,    64,    66,    49,    49,    49,    50,
      52,    59,    59,    59,    59,    59,    59,    59,    64,    59,
      64,    59,    64,    59,    59,    61,    59,    64,    59,    64,
      64,    59,    64,    59,    64,    59,    61,    66,    67,    67,
      67,    67,    59,     9,    10,    11,    12,     6,    43,    46,
      59,    59,    59,    60,    43,    61,    49,    49,    59,    18,
      45,    18,    31,    59,    64,    66,    67,    59,    61,    61,
      59,    45,    45
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, &yylloc, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval, &yylloc)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Type, Value, Location);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  fprintf (yyoutput, ": ");

# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  /* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;
/* Location data for the look-ahead symbol.  */
YYLTYPE yylloc;

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
  /* The locations where the error started and ended. */
  YYLTYPE yyerror_range[2];

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;
#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 0;
#endif


  yyvsp[0] = yylval;
    yylsp[0] = yylloc;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
	YYSTACK_RELOCATE (yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
  *++yylsp = yylloc;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, yylsp - yylen, yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 3:
#line 123 "graal.y"
    { graal_free_darrs(yyget_extra(scanner)); ;}
    break;

  case 5:
#line 127 "graal.y"
    {
                GVar *var = graal_get_var(yyget_extra(scanner), (yyvsp[-2].sval), TRUE);
                xfree((yyvsp[-2].sval));
                if (gvar_set_num(var, (yyvsp[0].dval)) != RETURN_SUCCESS) {
	            yyerror("assignment failed");
                    YYABORT;
                }
            ;}
    break;

  case 6:
#line 135 "graal.y"
    {
                GVar *var = graal_get_var(yyget_extra(scanner), (yyvsp[-2].sval), TRUE);
                xfree((yyvsp[-2].sval));
                if (gvar_set_bool(var, (yyvsp[0].ival)) != RETURN_SUCCESS) {
	            yyerror("assignment failed");
                    YYABORT;
                }
            ;}
    break;

  case 7:
#line 143 "graal.y"
    {
                GVar *var = graal_get_var(yyget_extra(scanner), (yyvsp[-2].sval), TRUE);
                xfree((yyvsp[-2].sval));
                if (gvar_set_arr(var, (yyvsp[0].darr)) != RETURN_SUCCESS) {
	            yyerror("assignment failed");
                    YYABORT;
                }
            ;}
    break;

  case 8:
#line 151 "graal.y"
    {
                GVar *var = graal_get_var(yyget_extra(scanner), (yyvsp[-2].sval), TRUE);
                xfree((yyvsp[-2].sval));
                if (gvar_set_str(var, (yyvsp[0].sval)) != RETURN_SUCCESS) {
                    xfree((yyvsp[0].sval));
	            yyerror("assignment failed");
                    YYABORT;
                } else {
                    xfree((yyvsp[0].sval));
                }
            ;}
    break;

  case 9:
#line 162 "graal.y"
    {
                if (gvar_set_num((yyvsp[-2].gvar), (yyvsp[0].dval)) != RETURN_SUCCESS) {
	            yyerror("assignment failed - check types");
                    YYABORT;
                }
            ;}
    break;

  case 10:
#line 168 "graal.y"
    {
                if (gvar_set_bool((yyvsp[-2].gvar), (yyvsp[0].ival)) != RETURN_SUCCESS) {
	            yyerror("assignment failed - check types");
                    YYABORT;
                }
            ;}
    break;

  case 11:
#line 174 "graal.y"
    {
                if (gvar_set_arr((yyvsp[-2].gvar), (yyvsp[0].darr)) != RETURN_SUCCESS) {
	            yyerror("assignment failed - check types");
                    YYABORT;
                }
            ;}
    break;

  case 12:
#line 180 "graal.y"
    {
                if (gvar_set_str((yyvsp[-2].gvar), (yyvsp[0].sval)) != RETURN_SUCCESS) {
                    xfree((yyvsp[0].sval));
	            yyerror("assignment failed - check types");
                    YYABORT;
                } else {
                    xfree((yyvsp[0].sval));
                }
            ;}
    break;

  case 13:
#line 189 "graal.y"
    {
                double val;
                gvar_get_num((yyvsp[-3].gvar), &val);
                gvar_set_num((yyvsp[-3].gvar), val + (yyvsp[0].dval));
            ;}
    break;

  case 14:
#line 194 "graal.y"
    {
                double val;
                gvar_get_num((yyvsp[-3].gvar), &val);
                gvar_set_num((yyvsp[-3].gvar), val - (yyvsp[0].dval));
            ;}
    break;

  case 15:
#line 199 "graal.y"
    {
                double val;
                gvar_get_num((yyvsp[-3].gvar), &val);
                gvar_set_num((yyvsp[-3].gvar), val*(yyvsp[0].dval));
            ;}
    break;

  case 16:
#line 204 "graal.y"
    {
                if ((yyvsp[0].dval) == 0) {
	            yyerror("divide by zero");
                    YYABORT;
                } else {
                    double val;
                    gvar_get_num((yyvsp[-3].gvar), &val);
                    gvar_set_num((yyvsp[-3].gvar), val/(yyvsp[0].dval));
                }
            ;}
    break;

  case 17:
#line 214 "graal.y"
    {
                DArray *da;
                gvar_get_arr((yyvsp[-5].gvar), &da);
                if ((yyvsp[-3].ival) < da->size) {
                    da->x[(yyvsp[-3].ival)] = (yyvsp[0].dval);
                } else {
	            yyerror("index beyond array bounds");
                    YYABORT;
                }
            ;}
    break;

  case 18:
#line 224 "graal.y"
    {
                DArray *da;
                gvar_get_arr((yyvsp[-3].gvar), &da);
                darray_add_val(da, (yyvsp[0].dval));
            ;}
    break;

  case 19:
#line 229 "graal.y"
    {
                DArray *da;
                gvar_get_arr((yyvsp[-3].gvar), &da);
                darray_add_val(da, -(yyvsp[0].dval));
            ;}
    break;

  case 20:
#line 234 "graal.y"
    {
                DArray *da;
                gvar_get_arr((yyvsp[-3].gvar), &da);
                darray_mul_val(da, (yyvsp[0].dval));
            ;}
    break;

  case 21:
#line 239 "graal.y"
    {
                if ((yyvsp[0].dval) == 0) {
	            yyerror("divide by zero");
                    YYABORT;
                } else {
                    DArray *da;
                    gvar_get_arr((yyvsp[-3].gvar), &da);
                    darray_mul_val(da, 1.0/(yyvsp[0].dval));
                }
            ;}
    break;

  case 22:
#line 249 "graal.y"
    {
                char *val, *buf;
                gvar_get_str((yyvsp[-3].gvar), &val);
                buf = copy_string(NULL, val);
                buf = concat_strings(buf, (yyvsp[0].sval));
                xfree((yyvsp[0].sval));
                gvar_set_str((yyvsp[-3].gvar), buf);
                xfree(buf);
            ;}
    break;

  case 23:
#line 258 "graal.y"
    {
                Graal *g = yyget_extra(scanner);
                GVarData prop;
                prop.num = (yyvsp[0].dval);
                if (graal_set_user_obj_prop(g, (yyvsp[-4].gobj), (yyvsp[-2].sval), GVarNum, prop) !=
                    RETURN_SUCCESS) {
	            yyerror("assignment failed");
                }
                xfree((yyvsp[-2].sval));
            ;}
    break;

  case 24:
#line 268 "graal.y"
    {
                Graal *g = yyget_extra(scanner);
                GVarData prop;
                prop.bool = (yyvsp[0].ival);
                if (graal_set_user_obj_prop(g, (yyvsp[-4].gobj), (yyvsp[-2].sval), GVarBool, prop) !=
                    RETURN_SUCCESS) {
	            yyerror("assignment failed");
                }
                xfree((yyvsp[-2].sval));
            ;}
    break;

  case 25:
#line 278 "graal.y"
    {
                Graal *g = yyget_extra(scanner);
                GVarData prop;
                prop.str = (yyvsp[0].sval);
                if (graal_set_user_obj_prop(g, (yyvsp[-4].gobj), (yyvsp[-2].sval), GVarStr, prop) !=
                    RETURN_SUCCESS) {
	            yyerror("assignment failed");
                }
                xfree((yyvsp[-2].sval));
                xfree((yyvsp[0].sval));
            ;}
    break;

  case 26:
#line 289 "graal.y"
    {
                Graal *g = yyget_extra(scanner);
                GVarData prop;
                prop.arr = (yyvsp[0].darr);
                if (graal_set_user_obj_prop(g, (yyvsp[-4].gobj), (yyvsp[-2].sval), GVarArr, prop) !=
                    RETURN_SUCCESS) {
	            yyerror("assignment failed");
                }
                xfree((yyvsp[-2].sval));
            ;}
    break;

  case 27:
#line 299 "graal.y"
    {
                GVarData vardata;
                vardata.num = (yyvsp[0].dval);
                graal_call_eval_proc(yyget_extra(scanner), GVarNum, vardata);
            ;}
    break;

  case 28:
#line 304 "graal.y"
    {
                GVarData vardata;
                vardata.bool = (yyvsp[0].ival);
                graal_call_eval_proc(yyget_extra(scanner), GVarBool, vardata);
            ;}
    break;

  case 29:
#line 309 "graal.y"
    {
                GVarData vardata;
                vardata.arr = (yyvsp[0].darr);
                graal_call_eval_proc(yyget_extra(scanner), GVarArr, vardata);
            ;}
    break;

  case 30:
#line 314 "graal.y"
    {
                GVarData vardata;
                vardata.str = (yyvsp[0].sval);
                graal_call_eval_proc(yyget_extra(scanner), GVarStr, vardata);
                xfree((yyvsp[0].sval));
            ;}
    break;

  case 31:
#line 320 "graal.y"
    {
                GVarData vardata;
                vardata.num = 0;
                graal_call_eval_proc(yyget_extra(scanner), GVarNil, vardata);
            ;}
    break;

  case 32:
#line 325 "graal.y"
    { gvar_clear((yyvsp[0].gvar)); ;}
    break;

  case 33:
#line 328 "graal.y"
    { graal_set_RHS(yyget_extra(scanner), TRUE); ;}
    break;

  case 34:
#line 331 "graal.y"
    { (yyval.gvar) = (yyvsp[0].gvar); ;}
    break;

  case 35:
#line 332 "graal.y"
    { (yyval.gvar) = (yyvsp[0].gvar); ;}
    break;

  case 36:
#line 333 "graal.y"
    { (yyval.gvar) = (yyvsp[0].gvar); ;}
    break;

  case 37:
#line 334 "graal.y"
    { (yyval.gvar) = (yyvsp[0].gvar); ;}
    break;

  case 38:
#line 335 "graal.y"
    { (yyval.gvar) = (yyvsp[0].gvar); ;}
    break;

  case 39:
#line 338 "graal.y"
    { (yyval.dval) = (yyvsp[0].dval); ;}
    break;

  case 40:
#line 339 "graal.y"
    {
                gvar_get_num((yyvsp[0].gvar), &(yyval.dval));
            ;}
    break;

  case 41:
#line 342 "graal.y"
    {
                (yyval.dval) = (yyvsp[0].dval);
            ;}
    break;

  case 42:
#line 345 "graal.y"
    { (yyval.dval) = (yyvsp[-2].dval) + (yyvsp[0].dval); ;}
    break;

  case 43:
#line 346 "graal.y"
    { (yyval.dval) = (yyvsp[-2].dval) - (yyvsp[0].dval); ;}
    break;

  case 44:
#line 347 "graal.y"
    { (yyval.dval) = (yyvsp[-2].dval) * (yyvsp[0].dval); ;}
    break;

  case 45:
#line 348 "graal.y"
    {
                if ((yyvsp[0].dval) == 0.0) {
	            yyerror("divide by zero");
                    YYABORT;
                } else {
	            (yyval.dval) = (yyvsp[-2].dval) / (yyvsp[0].dval);
                }
	    ;}
    break;

  case 46:
#line 356 "graal.y"
    {
                if ((yyvsp[-2].dval) < 0 && rint((yyvsp[0].dval)) != (yyvsp[0].dval)) {
                    yyerror("negative value raised to non-integer power");
                    YYABORT;
                } else if ((yyvsp[-2].dval) == 0.0 && (yyvsp[0].dval) <= 0.0) {
                    yyerror("zero raised to non-positive power");
                    YYABORT;
                } else {
                    (yyval.dval) = pow((yyvsp[-2].dval), (yyvsp[0].dval));
                }
            ;}
    break;

  case 47:
#line 367 "graal.y"
    { (yyval.dval) = -(yyvsp[0].dval); ;}
    break;

  case 48:
#line 368 "graal.y"
    { (yyval.dval) = (yyvsp[0].dval); ;}
    break;

  case 49:
#line 369 "graal.y"
    { (yyval.dval) = (yyvsp[-1].dval); ;}
    break;

  case 50:
#line 370 "graal.y"
    {
                if ((yyvsp[-1].ival) < (yyvsp[-3].darr)->size) {
                    (yyval.dval) = (yyvsp[-3].darr)->x[(yyvsp[-1].ival)];
                } else {
	            yyerror("index beyond array bounds");
                    YYABORT;
                }
            ;}
    break;

  case 51:
#line 378 "graal.y"
    { (yyval.dval) = (yyvsp[-4].ival) ? (yyvsp[-2].dval):(yyvsp[0].dval); ;}
    break;

  case 52:
#line 379 "graal.y"
    { (yyval.dval) = (yyvsp[-1].darr) ? (yyvsp[-1].darr)->size:0; ;}
    break;

  case 53:
#line 380 "graal.y"
    {
                (yyval.dval) = strlen((yyvsp[-1].sval));
                xfree((yyvsp[-1].sval));
            ;}
    break;

  case 54:
#line 386 "graal.y"
    {
                int itmp = rint((yyvsp[0].dval));
                if (fabs(itmp - (yyvsp[0].dval)) > 1.e-6) {
                    yyerror("Non-integer value supplied for integer");
                    YYABORT;
                } else {
                    (yyval.ival) = itmp;
                }
	    ;}
    break;

  case 55:
#line 395 "graal.y"
    {
                if ((yyvsp[0].ival) == 0) {
	            yyerror("divide by zero");
                    YYABORT;
                } else {
                    (yyval.ival) = (int) rint((yyvsp[-2].ival)) % (int) rint((yyvsp[0].ival));
                }
            ;}
    break;

  case 56:
#line 405 "graal.y"
    {
                if ((yyvsp[0].ival) < 0) {
                    yyerror("Negative value supplied for non-negative");
                    YYABORT;
                } else {
                    (yyval.ival) = (yyvsp[0].ival);
                }
	    ;}
    break;

  case 57:
#line 415 "graal.y"
    {
                (yyval.darr) = NULL;
            ;}
    break;

  case 58:
#line 418 "graal.y"
    {
                (yyval.darr) = darray_new(1);
                if ((yyval.darr)) {
                    REGISTER_DARR((yyval.darr));
                    darray_set_val((yyval.darr), 0, (yyvsp[0].dval));
                }
            ;}
    break;

  case 59:
#line 425 "graal.y"
    {
                darray_append_val((yyvsp[-2].darr), (yyvsp[0].dval));
                (yyval.darr) = (yyvsp[-2].darr);
            ;}
    break;

  case 60:
#line 431 "graal.y"
    { (yyval.darr) = (yyvsp[-1].darr); ;}
    break;

  case 61:
#line 432 "graal.y"
    {
                DArray *da;
                gvar_get_arr((yyvsp[0].gvar), &da);
                (yyval.darr) = darray_copy(da);
                if ((yyval.darr)) {
                    REGISTER_DARR((yyval.darr));
                }
            ;}
    break;

  case 62:
#line 440 "graal.y"
    {
                (yyval.darr) = (yyvsp[0].darr);
                REGISTER_DARR((yyval.darr));
            ;}
    break;

  case 63:
#line 447 "graal.y"
    { (yyval.darr) = (yyvsp[0].darr); ;}
    break;

  case 64:
#line 448 "graal.y"
    {
                if ((yyvsp[-3].ival) >= (yyvsp[-5].darr)->size || (yyvsp[-1].ival) >= (yyvsp[-5].darr)->size) {
	            yyerror("index beyond array bounds");
                    YYABORT;
                } else
                if ((yyvsp[-3].ival) > (yyvsp[-1].ival)) {
	            yyerror("non-positive index range");
                    YYABORT;
                } else {
                    (yyval.darr) = darray_slice((yyvsp[-5].darr), (yyvsp[-3].ival), (yyvsp[-1].ival));
                    REGISTER_DARR((yyval.darr));
                }
            ;}
    break;

  case 65:
#line 461 "graal.y"
    {
                (yyval.darr) = darray_concat((yyvsp[-2].darr), (yyvsp[0].darr));
                REGISTER_DARR((yyval.darr));
            ;}
    break;

  case 66:
#line 465 "graal.y"
    {
                (yyval.darr) = darray_copy((yyvsp[-2].darr));
                if ((yyval.darr)) {
                    REGISTER_DARR((yyval.darr));
                    darray_add_val((yyval.darr), (yyvsp[0].dval));
                }
            ;}
    break;

  case 67:
#line 472 "graal.y"
    {
                (yyval.darr) = darray_copy((yyvsp[0].darr));
                if ((yyval.darr)) {
                    REGISTER_DARR((yyval.darr));
                    darray_add_val((yyval.darr), (yyvsp[-2].dval));
                }
            ;}
    break;

  case 68:
#line 479 "graal.y"
    {
                if ((yyvsp[-2].darr)->size != (yyvsp[0].darr)->size) {
	            yyerror("vector lengths mismatch");
                    YYABORT;
                } else {
                    (yyval.darr) = darray_copy((yyvsp[-2].darr));
                    if ((yyval.darr)) {
                        REGISTER_DARR((yyval.darr));
                        darray_add((yyval.darr), (yyvsp[0].darr));
                    }
                }
            ;}
    break;

  case 69:
#line 491 "graal.y"
    {
                (yyval.darr) = darray_copy((yyvsp[-2].darr));
                if ((yyval.darr)) {
                    REGISTER_DARR((yyval.darr));
                    darray_add_val((yyval.darr), -(yyvsp[0].dval));
                }
            ;}
    break;

  case 70:
#line 498 "graal.y"
    {
                (yyval.darr) = darray_copy((yyvsp[0].darr));
                if ((yyval.darr)) {
                    REGISTER_DARR((yyval.darr));
                    darray_mul_val((yyval.darr), -1.0);
                    darray_add_val((yyval.darr), (yyvsp[-2].dval));
                }
            ;}
    break;

  case 71:
#line 506 "graal.y"
    {
                if ((yyvsp[-2].darr)->size != (yyvsp[0].darr)->size) {
	            yyerror("vector lengths mismatch");
                    YYABORT;
                } else {
                    (yyval.darr) = darray_copy((yyvsp[-2].darr));
                    if ((yyval.darr)) {
                        REGISTER_DARR((yyval.darr));
                        darray_sub((yyval.darr), (yyvsp[0].darr));
                    }
                }
            ;}
    break;

  case 72:
#line 518 "graal.y"
    {
                (yyval.darr) = darray_copy((yyvsp[-2].darr));
                if ((yyval.darr)) {
                    darray_mul_val((yyval.darr), (yyvsp[0].dval));
                }
            ;}
    break;

  case 73:
#line 524 "graal.y"
    {
                (yyval.darr) = darray_copy((yyvsp[0].darr));
                if ((yyval.darr)) {
                    REGISTER_DARR((yyval.darr));
                    darray_mul_val((yyval.darr), (yyvsp[-2].dval));
                }
            ;}
    break;

  case 74:
#line 531 "graal.y"
    {
                if ((yyvsp[-2].darr)->size != (yyvsp[0].darr)->size) {
	            yyerror("vector lengths mismatch");
                    YYABORT;
                } else {
                    (yyval.darr) = darray_copy((yyvsp[-2].darr));
                    if ((yyval.darr)) {
                        REGISTER_DARR((yyval.darr));
                        darray_mul((yyval.darr), (yyvsp[0].darr));
                    }
                }
            ;}
    break;

  case 75:
#line 543 "graal.y"
    {
                (yyval.darr) = darray_copy((yyvsp[-2].darr));
                if ((yyval.darr)) {
                    REGISTER_DARR((yyval.darr));
                    if ((yyvsp[0].dval) == 0.0) {
	                yyerror("divide by zero");
                        YYABORT;
                    } else {
                        darray_mul_val((yyval.darr), 1.0/(yyvsp[0].dval));
                    }
                }
            ;}
    break;

  case 76:
#line 555 "graal.y"
    {
                if ((yyvsp[-2].darr)->size != (yyvsp[0].darr)->size) {
	            yyerror("vector lengths mismatch");
                    YYABORT;
                } else {
                    (yyval.darr) = darray_copy((yyvsp[-2].darr));
                    if ((yyval.darr)) {
                        REGISTER_DARR((yyval.darr));
                        if (darray_div((yyval.darr), (yyvsp[0].darr)) != RETURN_SUCCESS) {
	                    yyerror("divide by zero");
                            YYABORT;
                        }
                    }
                }
            ;}
    break;

  case 77:
#line 570 "graal.y"
    {
                double vmin;
                darray_min((yyvsp[-2].darr), &vmin);
                if (vmin < 0 && rint((yyvsp[0].dval)) != (yyvsp[0].dval)) {
                    yyerror("negative value raised to non-integer power");
                    YYABORT;
                } else if (darray_has_zero((yyvsp[-2].darr)) && (yyvsp[0].dval) <= 0.0) {
                    yyerror("zero raised to non-positive power");
                    YYABORT;
                } else {
                    darray_pow((yyval.darr), (yyvsp[0].dval));
                }
            ;}
    break;

  case 78:
#line 583 "graal.y"
    {
                (yyval.darr) = darray_copy((yyvsp[0].darr));
                if ((yyval.darr)) {
                    REGISTER_DARR((yyval.darr));
                    darray_mul_val((yyval.darr), -1.0);
                }
            ;}
    break;

  case 79:
#line 590 "graal.y"
    { (yyval.darr) = (yyvsp[0].darr); ;}
    break;

  case 80:
#line 591 "graal.y"
    { (yyval.darr) = (yyvsp[-1].darr); ;}
    break;

  case 81:
#line 594 "graal.y"
    { (yyval.sval) = (yyvsp[0].sval); ;}
    break;

  case 82:
#line 595 "graal.y"
    {
                char *s;
                gvar_get_str((yyvsp[0].gvar), &s);
                (yyval.sval) = copy_string(NULL, s);
            ;}
    break;

  case 83:
#line 602 "graal.y"
    { (yyval.sval) = (yyvsp[0].sval); ;}
    break;

  case 84:
#line 603 "graal.y"
    {
                (yyval.sval) = (yyvsp[0].sval);
            ;}
    break;

  case 85:
#line 606 "graal.y"
    {
                (yyval.sval) = concat_strings((yyvsp[-2].sval), (yyvsp[0].sval));
                xfree((yyvsp[0].sval));
            ;}
    break;

  case 86:
#line 610 "graal.y"
    {
                if ((yyvsp[-3].ival) > (yyvsp[-1].ival)) {
	            xfree((yyvsp[-5].sval));
                    yyerror("non-positive index range");
                    YYABORT;
                } else
                if ((yyvsp[-1].ival) >= strlen((yyvsp[-5].sval))) {
	            xfree((yyvsp[-5].sval));
	            yyerror("index beyond string length");
                    YYABORT;
                } else {
                    unsigned int len = (yyvsp[-1].ival) - (yyvsp[-3].ival) + 1;
                    (yyval.sval) = xmalloc(len + 1);
                    if ((yyval.sval)) {
                        memcpy((yyval.sval), (yyvsp[-5].sval) + (yyvsp[-3].ival), len);
                        (yyval.sval)[len] = '\0';
                    }
	            xfree((yyvsp[-5].sval));
                }
            ;}
    break;

  case 87:
#line 632 "graal.y"
    { (yyval.ival) = TRUE; ;}
    break;

  case 88:
#line 633 "graal.y"
    { (yyval.ival) = FALSE; ;}
    break;

  case 89:
#line 634 "graal.y"
    {
                gvar_get_bool((yyvsp[0].gvar), &(yyval.ival));
            ;}
    break;

  case 90:
#line 637 "graal.y"
    {
                (yyval.ival) = (yyvsp[0].ival);
            ;}
    break;

  case 91:
#line 640 "graal.y"
    { (yyval.ival) = ((yyvsp[-2].dval) == (yyvsp[0].dval) ? TRUE:FALSE); ;}
    break;

  case 92:
#line 641 "graal.y"
    { (yyval.ival) = ((yyvsp[-2].dval) != (yyvsp[0].dval) ? TRUE:FALSE); ;}
    break;

  case 93:
#line 642 "graal.y"
    { (yyval.ival) = ((yyvsp[-2].dval) <= (yyvsp[0].dval) ? TRUE:FALSE); ;}
    break;

  case 94:
#line 643 "graal.y"
    { (yyval.ival) = ((yyvsp[-2].dval) >= (yyvsp[0].dval) ? TRUE:FALSE); ;}
    break;

  case 95:
#line 644 "graal.y"
    { (yyval.ival) = ((yyvsp[-2].dval) < (yyvsp[0].dval) ? TRUE:FALSE); ;}
    break;

  case 96:
#line 645 "graal.y"
    { (yyval.ival) = ((yyvsp[-2].dval) > (yyvsp[0].dval) ? TRUE:FALSE); ;}
    break;

  case 97:
#line 646 "graal.y"
    { (yyval.ival) = (yyvsp[-2].ival) == (yyvsp[0].ival); ;}
    break;

  case 98:
#line 647 "graal.y"
    { (yyval.ival) = (yyvsp[-2].ival) != (yyvsp[0].ival); ;}
    break;

  case 99:
#line 648 "graal.y"
    { (yyval.ival) = (yyvsp[-2].ival) || (yyvsp[0].ival); ;}
    break;

  case 100:
#line 649 "graal.y"
    { (yyval.ival) = (yyvsp[-2].ival) && (yyvsp[0].ival); ;}
    break;

  case 101:
#line 650 "graal.y"
    { (yyval.ival) = !(yyvsp[0].ival); ;}
    break;

  case 102:
#line 651 "graal.y"
    { (yyval.ival) = (yyvsp[-1].ival); ;}
    break;

  case 103:
#line 654 "graal.y"
    {
                Graal *g = yyget_extra(scanner);
                (yyval.gobj) = (yyvsp[0].gobj);
                g->current_obj = (yyvsp[0].gobj);
            ;}
    break;

  case 104:
#line 659 "graal.y"
    { SET_DOTCONTEXT(GContextColumn); ;}
    break;

  case 105:
#line 659 "graal.y"
    {
                Graal *g = yyget_extra(scanner);
                (yyval.gobj) = (yyvsp[0].gobj);
                g->current_obj = (yyvsp[0].gobj);
            ;}
    break;


    }

/* Line 1037 of yacc.c.  */
#line 2307 "parser.c"

  yyvsp -= yylen;
  yyssp -= yylen;
  yylsp -= yylen;

  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
                 yyerror_range[0] = *yylsp;
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 yydestruct ("Error: popping",
                             yystos[*yyssp], yyvsp, yylsp);
	       }
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyerror_range[0] = yylsp[1-yylen];
  yylsp -= yylen;
  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping", yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the look-ahead.  YYLOC is available though. */
  YYLLOC_DEFAULT (yyloc, yyerror_range - 1, 2);
  *++yylsp = yyloc;

  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yydestruct ("Error: discarding lookahead",
              yytoken, &yylval, &yylloc);
  yychar = YYEMPTY;
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 665 "graal.y"


int graal_parse(Graal *g, const char *s, void *context)
{
    int retval;
    YY_BUFFER_STATE buffer = yy_scan_string(s, g->scanner);
    
    g->default_obj = context;
    g->current_obj = context;

    g->dot_context = GContextNone;
    g->RHS         = FALSE;
    
    if (yyparse(g->scanner) == 0) {
        retval = RETURN_SUCCESS;
    } else {
        retval = RETURN_FAILURE;
    }
    
    yy_delete_buffer(buffer, g->scanner);
    
    return retval;
}

